dBase IV AR_LEN Function

FUNCTION ar_len
PARAMETERS ar_name
PRIVATE ar_name, min, mid, max, rvalue

IF isarray(ar_name)           &&  we have an array

  min = 0
  max = 2048                  &&  larger than max array size

  IF ar_1dim(ar_name)         &&  one dimension array

    DO WHILE .t.

      mid = (max + min) / 2

***  If the next higher element is undefined then the length
***  of the array equals the mid value.

      IF type(ar_name+ '[mid]') # 'U' 

        IF type(ar_name + '[mid+1]') = 'U'
          rvalue = mid        &&  stuff rvalue
          EXIT
        ELSE
          min = mid
        ENDIF

      ELSE
        max = mid
      ENDIF

    ENDDO

  ELSE                        &&  if array is 2 dim

    DO WHILE .t.

      mid = (max + min) / 2

***  If the next higher element is undefined then the length
***  of the array equals the mid value.

      IF type(ar_name + '[mid,1]') # 'U' 

        IF type(ar_name + '[mid+1,1]') = 'U'
          rvalue = mid        &&  stuff rvalue
          EXIT
        ELSE
          min = mid
        ENDIF

      ELSE
        max = mid
      ENDIF

    ENDDO

  ENDIF

ELSE                          &&  not an array!
  ?? lchr(7)
  rvalue = -1
ENDIF

RETURN(rvalue)

